import pyglet
import random
import settings
import math

class FogParticle(object):
    def __init__(self, mapcontext, img, batches):
        self.mapcontext = mapcontext
        self.sprite = pyglet.sprite.Sprite(img, batch=random.choice(batches))
        self.multiplier = 1
        self.remake()
        self.life = 0#abs(random.random())*self.max_life
        self.sprite.opacity = 0#self.life*10
        
    
    def remake(self):
        self.sprite.set_position(abs(random.random()) * settings.world_width-self.sprite.image.width*0.5*self.sprite.scale*settings.scale,
                                 abs(random.random()) * settings.world_height- self.sprite.image.height*0.5*self.sprite.scale*settings.scale)
        self.sprite.scale = (abs(random.random())+1) * settings.scale
        self.max_life = (random.random() + 1) * 8
        self.life = 0
        self.sprite.opacity = self.life*10
        
    def update(self, dt):
        self.life += (dt * 4) * self.multiplier
        self.sprite.opacity = self.life*10
        if self.life > self.max_life:
            self.multiplier *= -1
        if self.life < 0:
            self.remake()
            self.multiplier *= -1
        
class Weather(object):
    
    def __init__(self, mapcontext):
        img = pyglet.resource.image('data/particles/fog.png')
        
        self.foreground_batch = pyglet.graphics.Batch()
        self.background_batch = pyglet.graphics.Batch()
        
        self.particles = []
        num_particles = int(settings.world_width*1.25)
        print num_particles
        for i in xrange(num_particles):
            p = FogParticle(mapcontext, img, [self.foreground_batch,self.foreground_batch, self.background_batch])
            self.particles.append(p)
        
    def update(self, dt):
        for p in self.particles:
            p.update(dt)
    
    def draw_foreground(self):
        self.foreground_batch.draw()
        
    def draw_background(self):
        self.background_batch.draw()